/* This code produces the Figure 4 (a) (b) and (c).  */

preserve

gen hinit=1 if inittoth!=. & inittoth<20
replace hinit=2 if inittoth!=. & inittoth>60

tab hinit if year==0

table year if inittoth!=0 & hinit==1 & survive7==1, contents(count labor_ count toth_ count logy)
table year if inittoth!=0 & hinit==2 & survive7==1, contents(count labor_ count toth_ count logy)

collapse (mean) toth_  labor_ nonemploy logy (p90) p90labor_=labor_ [aw=samplingweight_0] if inittoth!=0 & survive7==1, by(year hinit)

twoway (line labor_ year if hinit==1, lpattern(solid) lcolor(blue)) (line labor_ year if hinit==2, lpattern(dash) lcolor(red)) ///
, ytitle("Hired labor", size(large) ) xtitle("Firm age", size(large))  ///
ylabel(,nogrid) xlabel(0(1)7) graphregion(margin(right) fcolor(white) lcolor(white)) plotregion(margin(medlarge)) ///
legend(order(1 "Initial hours < 20" 2 "Initial hours > 60") region(lcolor(white)) rows(1))
graph export "export/age_hinit.pdf", as(pdf) replace

twoway (line toth_ year if hinit==1, lpattern(solid) lcolor(blue)) (line toth_ year if hinit==2, lpattern(dash) lcolor(red)) ///
, ytitle("Owner hours", size(large) ) xtitle("Firm age", size(large))  ///
ylabel(,nogrid) xlabel(0(1)7) graphregion(margin(right) fcolor(white) lcolor(white)) plotregion(margin(medlarge)) ///
legend(order(1 "Initial hours < 20" 2 "Initial hours > 60") region(lcolor(white)) rows(1))
graph export "export/toth_hinit.pdf", as(pdf) replace

twoway (line logy year if hinit==1, lpattern(solid) lcolor(blue)) (line logy year if hinit==2, lpattern(dash) lcolor(red)) ///
, ytitle("Output (logs)", size(large) ) xtitle("Firm age", size(large))  ///
ylabel(,nogrid) xlabel(0(1)7) graphregion(margin(right) fcolor(white) lcolor(white)) plotregion(margin(medlarge)) ///
legend(order(1 "Initial hours < 20" 2 "Initial hours > 60") region(lcolor(white)) rows(1))
graph export "export/logy_hinit.pdf", as(pdf) replace


restore
