/* For the Figure 4 of the paper, we use the KFS confidential microdata file through the NORC Data Enclave's secure remote access. This access is made available thanks to support of the Kauffman Foundation.
One can read the details of how to get access to this data on https://www.kauffman.org/entrepreneurship/research/kauffman-firm-survey/. */

set maxvar 9000
use "K:\Datasets\Common\kfs8\Kfs8_enclave_14oct13.dta", clear
*save "H:\WY_NORC\Kfs8_enclave_14oct13.dta", replace


forvalues j=0/7 {
gen toth_`j'=g1b1_hours_owner_01_`j' if g1b1_hours_owner_01_`j'!=.
forvalues i=2/4 {
replace toth_`j'=toth_`j' + g1b1_hours_owner_0`i'_`j' if g1b1_hours_owner_0`i'_`j'!=.
}
}

forvalues j=0/7 {
gen owneremph`j'=g1b1_hours_owner_01_`j' if g1a_emp_owner_01_`j'==1
forvalues i=2/4 {
replace owneremph`j'=owneremph`j'+g1b1_hours_owner_0`i'_`j' if g1a_emp_owner_0`i'_`j'==1
}
}

forvalues j=0/7 {
gen labor_`j'=0 if c5_num_employees_`j'==0
replace labor_`j'=c6_num_ft_employees_`j'*40 if c6_num_ft_employees_`j'!=. 
replace labor_`j'= labor_`j'+c7_num_pt_employees_`j'*20 if c7_num_pt_employees_`j'!=.
*replace labor_`j'= labor_`j'- owneremph`j' if owneremph`j' !=.
}

forvalues j=0/7 {
gen hoL_`j'=toth_`j'/labor_`j'
}

forvalues i=1/4 {
forvalues j=0/7 {
gen eduowner`i'_`j'=1 if g9_education_owner_0`i'_`j'==1 | g9_education_owner_0`i'_`j'==2
replace eduowner`i'_`j'=2 if g9_education_owner_0`i'_`j'==3 | g9_education_owner_0`i'_`j'==4  | g9_education_owner_0`i'_`j'==5   | g9_education_owner_0`i'_`j'==6
replace eduowner`i'_`j'=3 if g9_education_owner_0`i'_`j'==7 | g9_education_owner_0`i'_`j'==8
replace eduowner`i'_`j'=4 if g9_education_owner_0`i'_`j'==9 | g9_education_owner_0`i'_`j'==10
}
}



forvalues j=0/7 {
gen edutot_`j'=eduowner1_`j' if eduowner1_`j'!=.
forvalues i=2/4 {
replace edutot_`j'=edutot_`j' + eduowner`i'_`j' if eduowner`i'_`j'!=.
}
}

forvalues i=1/4 {
forvalues j=0/7 {
gen femaleowner`i'_`j'=1 if g10_gender_owner_0`i'_`j'==2 
replace femaleowner`i'_`j'=0 if g10_gender_owner_0`i'_`j'==1
}
}

forvalues j=0/7 {
gen femaletotowner_`j'=femaleowner1_`j' if femaleowner1_`j'!=.
forvalues i=2/4 {
replace femaletotowner_`j'=femaletotowner_`j' + femaleowner`i'_`j' if femaleowner`i'_`j'!=.
}
}



forvalues j=0/7 {
gen countm_`j'=0 
replace countm_`j'=e1_c_num_exec_admin_`j' if e1_c_num_exec_admin_`j'!=.
replace countm_`j'=countm_`j' - c3a_owner_operators_`j' if c3a_owner_operators_`j'!=.
replace countm_`j'=0  if countm_`j'!=. & countm_`j'<0
}

forvalues j=0/7 {
gen countw_`j'=0 
replace countw_`j'=countw_`j' + e1_b_num_sales_`j' if e1_b_num_sales_`j'!=.
replace countw_`j'=countw_`j' + e1_d_num_resdev_`j' if e1_d_num_resdev_`j'!=.
replace countw_`j'=countw_`j' + e1_e_num_prod_manu_`j' if e1_e_num_prod_manu_`j'!=.
replace countw_`j'=countw_`j' + e1_g_num_fin_admin_`j' if e1_g_num_fin_admin_`j'!=.

}

sum countm_* 
sum countw_* 


forvalues j=0/7 {
gen laborm_`j'=0 if c5_num_employees_`j'==0
replace laborm_`j'=countm_`j'/(countm_`j'+countw_`j')*labor_`j'

gen laborw_`j'=0 if c5_num_employees_`j'==0
replace laborw_`j'=countw_`j'/(countm_`j'+countw_`j')*labor_`j'
replace laborw_`j'=labor_`j' if laborm_`j'==0

}

sum laborm*
sum laborw*


forvalues j=0/7 {
gen hirem_`j'=0 if countm_`j'!=.
replace hirem_`j'=1 if countm_`j'!=. & countm_`j'>0

gen manag_`j'=0 if hirem_`j'!=.
replace manag_`j'= laborm_`j'/40  if hirem_`j'==1
}

forvalues j=0/7 {
gen rawinput_`j'=f17a_total_exp_`=2004+`j''_amt_`j'
replace rawinput_`j'=rawinput_`j'- f18a_wage_exp_`=2004+`j''_amt_`j' if c5_num_employees_`j'>0 & c5_num_employees_`j'!=. 
gen revenue_`j' = f16a_rev_`=2004+`j''_amt_`j'
gen va_`j' = revenue_`j'-rawinput_`j'
}

forvalues j=0/7 {
gen payroll_`j'=f18a_wage_exp_`=2004+`j''_amt_`j'
replace payroll_`j'=0 if c5_num_employees_`j'==0 & payroll_`j'==.
}



forvalues j=0/7 {
gen totexp_`j'=f17a_total_exp_`=2004+`j''_amt_`j'
}


forvalues j=0/7 {
gen costoppk_`j'=0
replace costoppk_`j'=(0.05+0.02)*f29_assetval_landbuild_`j' if f29_assetval_landbuild_`j'!=.
replace costoppk_`j'=costoppk_`j'+(0.05+0.06)*f29_assetval_equip_`j' if f29_assetval_equip_`j'!=.
replace costoppk_`j'=costoppk_`j'+(0.05+0.12 )*f29_assetval_veh_`j' if f29_assetval_veh_`j'!=.

gen valk_`j'=0
replace valk_`j'=f29_assetval_landbuild_`j' if f29_assetval_landbuild_`j'!=.
replace valk_`j'=valk_`j'+f29_assetval_equip_`j' if f29_assetval_equip_`j'!=.
replace valk_`j'=valk_`j'+f29_assetval_veh_`j' if f29_assetval_veh_`j'!=.

gen rentk_`j'=(f20_mach_`j'==1| f21_land_rent_`j'==1 | f22_mach_rent_`j'==1)
}


forvalues j=0/7 {
gen oneowner_`j'=0
replace oneowner_`j'=1 if c3a_owner_operators_`j'<2 | c2_owners_`j'<2 | toth_`j'-g1b1_hours_owner_01_`j'<5
}

forvalues j=0/7 {
gen multiowner_`j'=0
replace multiowner_`j'=1 if (c3a_owner_operators_`j'>1 & c3a_owner_operators_`j'!=.) ///
 & (c2_owners_`j'>1  & c3a_owner_operators_`j'!=.) & (toth_`j'-g1b1_hours_owner_01_`j'>1 & toth_`j'-g1b1_hours_owner_01_`j'!=.)
}

gen operate_0=1
replace operate_0=0 if fstatus_0==21 | fstatus_0==22

gen operate_1=1
replace operate_1=0 if fstatus_1==21 | fstatus_1==22

forvalues j=2/7 {
gen operate_`j'=1
replace operate_`j'=0 if fstatus_f`j'==21 | fstatus_f`j'==22
}


forvalues j=1/7 {
gen survive`j'=0
replace survive`j'=1 if operate_`j'==1
}

gen operatealt_0=0
replace operatealt_0=1 if fstatus_0==1 

gen operatealt_1=0
replace operatealt_1=1 if fstatus_1==1

forvalues j=2/7 {
gen operatealt_`j'=0
replace operatealt_`j'=1 if fstatus_f`j'==1
}





forvalues j=0/7 {
gen laboro0_`j'=labor_`j'/labor_0
gen laboro0log_`j'=log(labor_`j')-log(labor_0)
}

gen initcostoppk=costoppk_0
gen initksholsh=costoppk_0/payroll_0
gen initlogvalk=log(valk_0)
gen initlogcostoppk=log(costoppk_0)
gen initlabor=labor_0
gen inittoth=toth_0
gen initnonemploy=(c5_num_employees_0==0)

** was saving here **

gen initlegstat=b2a_legal_status_0
sum laboro0_7 [aw=samplingweight_0], d
gen superstar=0
replace superstar=1 if laboro0_7>=r(p50) &  laboro0_7!=.
destring credrisk_7, replace force

keep mprid samplingweight_0 wgt_final_0 sampleinfo_naics_code_0 c5_num_employees_* c6_num_ft_employees_* ///
c3a_owner_operators_* toth_0- valk_7  a10_out_of_business_* a11_year_closed_* ///
e1_c_num_exec_admin_* e1_a_num_human_res_* e1_f_num_gen_admin_*  e1_g_num_fin_admin* laborm* laborw* ///
survive* c10_morelocations_* c11_num_locations_* multiowner_* e1_b_num_sales_* e1_e_num_prod_manu_*  ///
totexp* f24_profit_amt* rentk* laboro0_* laboro0log_* operate_* operatealt_* initcostoppk initksholsh initlogvalk ///
initlogcostoppk initlabor initlegstat inittoth initnonemploy superstar credrisk*

drop owneremp* eduowner2* eduowner3* eduowner4* femaleowner2* femaleowner3* femaleowner4* 

reshape long c5_num_employees_ c6_num_ft_employees_ c3a_owner_operators_ eduowner1_ edutot_ femaleowner1_ femaletotowner_ toth_ labor_ hoL_ unitm_ hirem_ ///
manag_ rawinput_ revenue_ va_ payroll_ costoppk_ valk_ a10_out_of_business_ a11_year_closed_ ///
e1_c_num_exec_admin_ e1_a_num_human_res_ e1_f_num_gen_admin_  e1_g_num_fin_admin_ c10_morelocations_ c11_num_locations_  ///
laborm_ laborw_ multiowner_ e1_b_num_sales_ e1_e_num_prod_manu_ totexp_ f24_profit_amt_ rentk_ laboro0_ laboro0log_ operate_ operatealt_ credrisk_, i(mprid) j(year)

keep if multiowner!=1


tsset mprid year

gen exit_=0 if operate_==1
replace exit_=1 if operate_==0 & L1.operate_==1
replace exit_=. if L1.operate_==0

gen nonemploy=0 if c5!=.
replace nonemploy=1 if c5==0

gen nonemployft=0 if c6!=.
replace nonemployft=1 if c6==0

gen y=f24_profit_amt+payroll_+costopp
replace y=y+payroll*40/labor_ if c5_>0
gen logy=log(y)


run "H:\WY_NORC\before_after.do"

