cd "F:\Entrepenuer\Clean Codes\Moments SIPP"
use data3_e3_wave, clear
*computes annualized autocorrelation of hours


*make the data yearly
sort id pp_wave
by id: gen n_wave = _n
gen year_n = 1
replace year_n =2 if n_wave>3 & n_wave<=6
replace year_n =3 if n_wave>6 & n_wave<=9
replace year_n =4 if n_wave>9 & n_wave<=12
replace year_n =5 if n_wave>12 & n_wave<=15

collapse (sum) self_am emp_am self_hr_m emp_hr_m self_week u_comp (first) year suseqnum su_id h_add pp_entry pp_pnum sex race ethnicty panel_year white wpfinwgt (max) hhtnw, by(id year_n)

*generate self employment
gen self = 0
replace self=1 if self_am>emp_am
replace self=1 if emp_am<=0 & self_hr_m>0

*autocorrelation of hours
preserve
keep if self==1
sort id year_n
by id: gen dwave = year_n-year_n[_n-1]
replace dwave=1 if dwave==.
replace dwave = dwave>1
by id: gen index = sum(dwave)
egen id2 = group(id index)
sort id2 year_n
gen logh=log(self_hr_m/self_week)
sum logh [aweight=wpfinwgt]
by id2: gen lhours = self_hr_m[_n-1]
keep if lhours!=.
corr lhours self_hr_m [aweight=wpfinwgt]
restore


