function [grid,P] = Tauchen_asy(rho,N,sigma, mue)

%sigma is long run variance


grid_l = linspace(norminv(0.05,0,sqrt(sigma)),norminv(0.9,0,sqrt(sigma)),7); %left part of the grid
grid_r = linspace(norminv(0.91,0,sqrt(sigma)),norminv(0.999,0,sqrt(sigma)),N-7);
grid = [grid_l grid_r]+mue;
grid_d = diff(grid);
bounds=[-Inf grid(1:end-1)+grid_d/2 Inf]; % Bounds of Bins

% replace (-)Inf bounds, by finite numbers
bounds(1)=bounds(2)-99999999999;
bounds(end)=bounds(end-1)+99999999999;

sigma_e=sqrt(sigma*(1-rho^2));% Calculate short run Std
P=NaN(N); % Initialize Transition Probability Matrix

for i=1:N %state
    if i == 1
        grid_w = linspace(norminv(0.01,mue,sqrt(sigma)),bounds(i+1),1000)';
        grid_wp = normpdf(grid_w,mue,sqrt(sigma)); %probability to be at these points
        grid_wp = grid_wp./sum(grid_wp);
    elseif i==N
        grid_w = linspace(bounds(i),norminv(0.9995,mue,sqrt(sigma)),1000)';
        grid_wp = normpdf(grid_w,mue,sqrt(sigma)); %probability to be at these points
        grid_wp = grid_wp./sum(grid_wp);
    else
        grid_w = linspace(bounds(i),bounds(i+1),1000)';
        grid_wp = normpdf(grid_w,mue,sqrt(sigma)); %probability to be at these points
        grid_wp = grid_wp./sum(grid_wp);
    end
    for j=1:N %transition to
        pi = normcdf(bounds(j+1),rho*grid_w+(1-rho)*mue,sigma_e)-normcdf(bounds(j),rho*grid_w+(1-rho)*mue,sigma_e);
        P(i,j)= grid_wp'*pi;
%         P(i,j)=normcdf(bounds(j+1),rho*grid(i)+(1-rho)*mue,sigma_e)-normcdf(bounds(j),rho*grid(i)+(1-rho)*mue,sigma_e);
    end
end
 
% Make sure P is a Probability Matrix
ps=sum(P,2);
P=P./(repmat(ps,1,N));


end