#include "fintrf.h"
!----------------------------------------------------------------------------
! Gateway routine
!----------------------------------------------------------------------------
subroutine mexFunction(nlhs,plhs,nrhs,prhs)
    implicit none
    ! Arguments in mexFunction
      mwPointer  :: plhs(*), prhs(*)
      integer    :: nlhs, nrhs
    
    ! Function declarations
      mwPointer     mxCreateNumericArray ,mxGetPr, mxGetM, mxGetN
      mwPointer     mxGetDimensions, mxCreateDoubleMatrix
      integer(4)    mxClassIDFromClassName
      mwSize        mxGetNumberOfDimensions
      
      ! Pointers to input/output mxArrays:
      ! Input           
      mwPointer  :: Vold,na,nap,nz,nnu,nh,nw,agrid,agridp,nugrid,beta,gamma,sub &
                    ,r,P,Pnu,Pw,xia,sia,heutil,PI,PImax,PI_opt,hgrid,hmax

       ! Output
      mwPointer  :: V,index_a,index_h
      
    ! Array size information
      integer(4) :: Nx,Ny,complexFlag,classid,classid2    ! length of input (output) array
      mwSize     :: ndim
      mwSize     :: ndim2
      mwSize     :: dims(3)                      ! dimensions (for mxCreateNumericArray)
      mwSize     :: dims2(4)
!--------------------------------------------------------------------------------    
      !size of output vector
      ndim = mxGetNumberOfDimensions(prhs(1))
      
      ! Retrieve size of input arguments (also size of output argument)
      call mxCopyPtrToPtrArray(mxGetDimensions(prhs(1)), dims, mxGetNumberOfDimensions(prhs(1)))
	  
      classid = mxClassIDFromClassName('double')
      classid2 = mxClassIDFromClassName('int32')
      complexFlag = 0   

      ! Retrieve input parameter pointers
      Vold = mxGetPr(prhs(1))
      na = mxGetPr(prhs(2))
      nap = mxGetPr(prhs(3))
      nz = mxGetPr(prhs(4))
      nnu = mxGetPr(prhs(5))
      nh = mxGetPr(prhs(6))
      nw = mxGetPr(prhs(7))
      agrid = mxGetPr(prhs(8))
      agridp = mxGetPr(prhs(9))
      nugrid = mxGetPr(prhs(10))
      beta = mxGetPr(prhs(11))
      gamma = mxGetPr(prhs(12))
      sub = mxGetPr(prhs(13))
      r = mxGetPr(prhs(14))
      P = mxGetPr(prhs(15))
      Pnu = mxGetPr(prhs(16))
      Pw = mxGetPr(prhs(17))
      xia = mxGetPr(prhs(18))
      sia = mxGetPr(prhs(19))
      heutil = mxGetPr(prhs(20))
      PI = mxGetPr(prhs(21))
      PImax = mxGetPr(prhs(22))
      PI_opt = mxGetPr(prhs(23))
      hgrid = mxGetPr(prhs(24))
      hmax = mxGetPr(prhs(25))
     
     ! Create matrices for return arguments

     plhs(1) = mxCreateNumericArray(ndim, dims, classid, complexflag)
     plhs(2) = mxCreateNumericArray(ndim, dims, classid2, complexflag)
     plhs(3) = mxCreateNumericArray(ndim, dims, classid2, complexflag)

 
     V = mxGetPr(plhs(1))
     index_a = mxGetPr(plhs(2))
     index_h = mxGetPr(plhs(3))

!call computation function
	  call VFI(%val(V),%val(index_a),%val(index_h),%val(Vold),%val(na),%val(nap),%val(nz) &
          ,%val(nnu),%val(nh),%val(nw),%val(agrid),%val(agridp),%val(nugrid),%val(beta) &
          ,%val(gamma),%val(sub),%val(r),%val(P),%val(Pnu),%val(Pw),%val(xia),%val(sia) &
          ,%val(heutil),%val(PI),%val(PImax),%val(PI_opt),%val(hgrid),%val(hmax))
				       
      return  
      
    end subroutine
    
    
    
Subroutine VFI(V,index_a,index_h,Vold,na,nap,nz,nnu,nh,nw,agrid,agridp,nugrid,beta,gamma &
                ,sub,r,P,Pnu,Pw,xia,sia,heutil,PI,PImax,PI_opt,hgrid,hmax)

implicit none

integer(4), intent(in)                             :: na,nap,nz,nnu,nh,nw

real(8), dimension(na,nz,nnu,nw), intent(out)         :: V
integer(4), dimension(na,nz,nnu,nw), intent(out)      :: index_a,index_h
real(8), dimension(na,nz,nnu,nw), intent(in)          :: Vold
real(8), dimension(na,nz,nh), intent(in)          :: PI_opt
real(8), dimension(na,nz), intent(in)              :: PImax
real(8), dimension(na,nz,nh,4), intent(in)         :: PI
real(8), dimension(na), intent(in)                 :: agrid
real(8), dimension(nap), intent(in)                :: agridp,sia
integer(4), dimension(nap), intent(in)             :: xia
real(8), dimension(nnu), intent(in)                :: nugrid
real(8), dimension(nh), intent(in)                 :: hgrid
real(8), dimension(nh), intent(in)                 :: heutil
real(8), dimension(nz,nz), intent(in)              :: P
real(8), dimension(nnu,nnu), intent(in)            :: Pnu
real(8), dimension(nw,nw), intent(in)            :: Pw
real(8) ,intent(in)                                :: sub,gamma,beta,r,hmax


!define further variable
real(8), dimension(na,nz,nnu,nw)       :: EV,EV1,EV2
real(8), dimension(nap)             :: v_aux
real(8), dimension(nh)              :: val
real(8)                             :: aprime,h,aux_sub,resource,contu,consume,util_work
integer(4)                          :: i1,i2,i3,i4,i5,j1,j2,j3,j4,j10,index
integer(4), dimension(nap)          :: index_l_aux,index_h_aux
character*120                       :: line
!real(8), dimension(nap)              :: xxx
real(8)                             :: xxx

call CARRA(aux_sub,sub,gamma) !value for non attainable states

!expected value function over productivity
do i1 = 1,nz
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV1(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nz 
                    EV1(i2,i1,i4,i3) = EV1(i2,i1,i4,i3)+P(i1,j1)*Vold(i2,j1,i4,i3)
                end do
            end do
        end do
    end do
end do
    

!expected value function over leissure
do i1 = 1,nz 
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV2(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nnu 
                    EV2(i2,i1,i4,i3) = EV2(i2,i1,i4,i3)+Pnu(i4,j1)*EV1(i2,i1,j1,i3)
                end do
            end do
        end do
    end do
end do

!expected value function over worker productivity
do i1 = 1,nz 
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nw 
                    EV(i2,i1,i4,i3) = EV(i2,i1,i4,i3)+Pw(i3,j1)*EV2(i2,i1,i4,j1)
                end do
            end do
        end do
    end do
end do



do i2 = 1,nz
    do i4 = 1,nnu
        do i3 = 1,nw
            index = 1
            do i1 = 1,na !states
                do j1=1,index-1 !cannot be optimal choice
                    v_aux(j1) = aux_sub
                end do
                j1 = index-1
                do while (j1<nap) !choices  (use monotonicity of policy function)
                    j1 = j1+1
                    resource = (1+r)*agrid(i1)-agridp(j1)
                    if ((resource+PImax(i1,i2))>0.d0) then
                        contu = beta*((1-sia(j1))*EV(xia(j1),i2,i4,i3)+sia(j1)*EV(xia(j1)+1,i2,i4,i3))
                        index_h_aux(j1) = 1
                        v_aux(j1) = -100000000000000.d0
                        do j2=1,nh !blue
                            util_work = nugrid(i4)*heutil(j2)
                            consume = PI_opt(i1,i2,j2)+resource
                            consume = max(consume,sub)
                            consume = log(consume)
                            consume = consume-util_work
                            !do j4 = 1,4 !possible labor options
                            !    consume = PI(i1,i2,j2,j4)+resource
                            !    consume = max(consume,sub)
                            !    consume = log(consume)
                            !    !call CARRA(consume,consume,gamma)
                            !    consume = consume-util_work
                                if (consume>v_aux(j1)) then
                                    index_h_aux(j1) = j2
                            !        index_l_aux(j1) = j4
                                    v_aux(j1)=consume
                                end if
                            !end do
                        end do
                        v_aux(j1) = v_aux(j1)+contu
                    else
                        v_aux(j1:nap) = -100000000000000.d0
                        j1 = nap
                    end if
                end do
                !maximum over assets
                call max_val(V(i1,i2,i4,i3),index_a(i1,i2,i4,i3),v_aux,nap)
                !index_l(i1,i2,i4,i3) = index_l_aux(index_a(i1,i2,i4,i3))
                index_h(i1,i2,i4,i3) = index_h_aux(index_a(i1,i2,i4,i3))
                index = index_a(i1,i2,i4,i3)
            end do
        end do
    end do
end do

 

return
end subroutine

    

    
subroutine CARRA(util,c,gamma)

!define in and outputs
double precision, intent(in)    :: c,gamma
double precision, intent(out)   :: util

!define further variables
integer				:: i1
double precision    :: gamma_bar

gamma_bar = 1-gamma


util = (c**(gamma_bar))/(gamma_bar)
!util = log(c)

end subroutine

    
    
subroutine max_val(y,I,x,na)

!computes maximum (y) and index (I) of vector x, with length na.
!define in and outputs
integer(4), intent(in)	   :: na
real(8), intent(in)    :: x(na)
real(8), intent(out)    :: y
integer(4), intent(out)	   :: I

!define further variables
integer(4)				:: i1

y = x(1)
I = 1

do i1 = 2,na
	if (x(i1)>y) then
		y = x(i1)
		I = i1
	end if
end do

end subroutine

    

subroutine sub_mexWriteString(String)
  implicit none
  character(*),intent(in):: String
  call mexPrintf(achar(10))
  call mexPrintf(trim(adjustl(String)))
end subroutine sub_mexWriteString