#include "fintrf.h"
!----------------------------------------------------------------------------
! Gateway routine
!----------------------------------------------------------------------------
subroutine mexFunction(nlhs,plhs,nrhs,prhs)
    implicit none
    ! Arguments in mexFunction
      mwPointer  :: plhs(*), prhs(*)
      integer    :: nlhs, nrhs
    
    ! Function declarations
      mwPointer     mxCreateNumericArray ,mxGetPr, mxGetM, mxGetN
      mwPointer     mxGetDimensions, mxCreateDoubleMatrix
      integer(4)    mxClassIDFromClassName
      mwSize        mxGetNumberOfDimensions
      
      ! Pointers to input/output mxArrays:
      ! Input           
      mwPointer  :: Vold,consumeb,na,nap,nz,nnu,nh,nw,agrid,agridp,nugrid,hbgrid,beta,gamma,phi,sub &
                    ,r,wb,P,Pnu,xia,sia,hbutil,Pw

       ! Output
      mwPointer  :: V,index_h,index_a
      
    ! Array size information
      integer(4) :: Nx,Ny,complexFlag,classid,classid2    ! length of input (output) array
      mwSize     :: ndim
      mwSize     :: dims(4)                      ! dimensions (for mxCreateNumericArray)
!--------------------------------------------------------------------------------    
      !size of output vector
      ndim = mxGetNumberOfDimensions(prhs(1))
      
      ! Retrieve size of input arguments (also size of output argument)
      call mxCopyPtrToPtrArray(mxGetDimensions(prhs(1)), dims, mxGetNumberOfDimensions(prhs(1)))
	  
      classid = mxClassIDFromClassName('double')
      classid2 = mxClassIDFromClassName('int32')
      complexFlag = 0   

      ! Retrieve input parameter pointers
      Vold = mxGetPr(prhs(1))
      consumeb = mxGetPr(prhs(2))
      na = mxGetPr(prhs(3))
      nap = mxGetPr(prhs(4))
      nz = mxGetPr(prhs(5))
      nnu = mxGetPr(prhs(6))
      nh = mxGetPr(prhs(7))
      nw = mxGetPr(prhs(8))
      agrid = mxGetPr(prhs(9))
      agridp = mxGetPr(prhs(10))
      nugrid = mxGetPr(prhs(11))
      hbgrid = mxGetPr(prhs(12))
      beta = mxGetPr(prhs(13))
      gamma = mxGetPr(prhs(14))
      phi = mxGetPr(prhs(15))
      sub = mxGetPr(prhs(16))
      r = mxGetPr(prhs(17))
      wb = mxGetPr(prhs(18))
      P = mxGetPr(prhs(19))
      Pnu = mxGetPr(prhs(20))
      xia = mxGetPr(prhs(21))
      sia = mxGetPr(prhs(22))
      hbutil = mxGetPr(prhs(23))
      Pw = mxGetPr(prhs(24))
     
     ! Create matrices for return arguments

     plhs(1) = mxCreateNumericArray(ndim, dims, classid, complexflag)
     plhs(2) = mxCreateNumericArray(ndim, dims, classid2, complexflag)
     plhs(3) = mxCreateNumericArray(ndim, dims, classid2, complexflag)

 
     V = mxGetPr(plhs(1))
     index_h = mxGetPr(plhs(2))
     index_a = mxGetPr(plhs(3))

!call computation function
	  call VFI(%val(V),%val(index_h),%val(index_a),%val(Vold),%val(consumeb),%val(na),%val(nap),%val(nz) &
          ,%val(nnu),%val(nh),%val(nw),%val(agrid),%val(agridp),%val(nugrid),%val(hbgrid),%val(beta) &
          ,%val(gamma),%val(phi),%val(sub),%val(r),%val(wb),%val(P),%val(Pnu),%val(xia) &
          ,%val(sia),%val(hbutil),%val(Pw))
				       
      return  
      
    end subroutine
    
    
    
Subroutine VFI(V,index_h,index_a,Vold,consumeb,na,nap,nz,nnu,nh,nw,agrid,agridp,nugrid,hbgrid,beta,gamma &
                ,phi,sub,r,wb,P,Pnu,xia,sia,hbutil,Pw)

implicit none

integer(4), intent(in)                             :: na,nap,nz,nnu,nh,nw

real(8), dimension(na,nz,nnu,nw), intent(out)         :: V
integer(4), dimension(na,nz,nnu,nw), intent(out)      :: index_h,index_a
real(8), dimension(na,nz,nnu,nw), intent(in)          :: Vold
real(8), dimension(na,nap,nw), intent(in)          :: consumeb
real(8), dimension(na), intent(in)                 :: agrid
real(8), dimension(nap), intent(in)                :: agridp,sia
integer(4), dimension(nap), intent(in)             :: xia
real(8), dimension(nnu), intent(in)                :: nugrid
real(8), dimension(nh), intent(in)                 :: hbgrid
real(8), dimension(nz,nz), intent(in)              :: P
real(8), dimension(nnu,nnu), intent(in)            :: Pnu
real(8), dimension(nw,nw), intent(in)              :: Pw
real(8) ,intent(in)                                :: phi,sub,gamma,beta,r,wb,hbutil


!define further variable
real(8), dimension(na,nz,nnu,nw)       :: EV,EV1,EV2
real(8), dimension(nap)             :: v_aux
real(8), dimension(nh)              :: consume,val
real(8)                             :: aprime,h,aux_sub,resource,contu
integer(4)                          :: i1,i2,i3,i4,i5,j1,j2,index,x1
integer(4), dimension(nap)          :: index_h_aux
character*120                       :: line
real(8), dimension(nh)              :: xxx

call CARRA(aux_sub,sub,gamma) !value for non attainable states
    

!expected value function over productivity
do i1 = 1,nz
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV1(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nz 
                    EV1(i2,i1,i4,i3) = EV1(i2,i1,i4,i3)+P(i1,j1)*Vold(i2,j1,i4,i3)
                end do
            end do
        end do
    end do
end do
    

!expected value function over leissure
do i1 = 1,nz 
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV2(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nnu 
                    EV2(i2,i1,i4,i3) = EV2(i2,i1,i4,i3)+Pnu(i4,j1)*EV1(i2,i1,j1,i3)
                end do
            end do
        end do
    end do
end do

!expected value function over worker productivity
do i1 = 1,nz 
    do i2 = 1,na
        do i4 = 1,nnu
            do i3=1,nw
                EV(i2,i1,i4,i3) = 0.d0
                do j1 = 1,nw 
                    EV(i2,i1,i4,i3) = EV(i2,i1,i4,i3)+Pw(i3,j1)*EV2(i2,i1,i4,j1)
                end do
            end do
        end do
    end do
end do
    
!call sub_mexWriteString('head works')

do i2 = 1,nz
    do i4 = 1,nnu
        do i3 = 1,nw
            index = 1
            do i1 = 1,na !states
                do j1=1,index-1 !cannot be optimal choice
                    v_aux(j1) = aux_sub
                end do
                do j1 = index,nap !choices  (use monotonicity of policy function)
                    contu = beta*((1-sia(j1))*EV(xia(j1),i2,i4,i3)+sia(j1)*EV(xia(j1)+1,i2,i4,i3))
                    !index_h_aux(j1) = 1
                !v_aux(j1) = -100000000000000.d0
                !do j2 = 1,nh
                !    val(j2) = consumeb(i1,j1,j2)-nugrid(i4)*hbutil(j2)
                !    if (val(j2)>v_aux(j1)) then
                !        index_h_aux(j1) = j2
                !        v_aux(j1)=val(j2)
                !    end if
                !end do
                !v_aux(j1) = v_aux(j1)+contu
                    v_aux(j1) = consumeb(i1,j1,i3)-nugrid(i4)*hbutil+contu
                end do
                !maximum over assets
                call max_val(V(i1,i2,i4,i3),index_a(i1,i2,i4,i3),v_aux,nap)
                !index_h(i1,i2,i4) = index_h_aux(index_a(i1,i2,i4))
                index_h(i1,i2,i4,i3) = 5
                index = index_a(i1,i2,i4,i3)
            end do
        end do
    end do
end do

 

return
end subroutine

    

    
subroutine CARRA(util,c,gamma)

!define in and outputs
double precision, intent(in)    :: c,gamma
double precision, intent(out)   :: util

!define further variables
integer				:: i1
double precision    :: gamma_bar

gamma_bar = 1-gamma


util = (c**(gamma_bar))/(gamma_bar)
!util = log(c)

end subroutine

    
    
subroutine max_val(y,I,x,na)

!computes maximum (y) and index (I) of vector x, with length na.
!define in and outputs
integer(4), intent(in)	   :: na
real(8), intent(in)    :: x(na)
real(8), intent(out)    :: y
integer(4), intent(out)	   :: I

!define further variables
integer(4)				:: i1

y = x(1)
I = 1

do i1 = 2,na
	if (x(i1)>y) then
		y = x(i1)
		I = i1
	end if
end do

end subroutine

    

subroutine sub_mexWriteString(String)
  implicit none
  character(*),intent(in):: String
  call mexPrintf(achar(10))
  call mexPrintf(trim(adjustl(String)))
end subroutine sub_mexWriteString